diff --git a/src/backend/commands/variable.c b/src/backend/commands/variable.c
index e555fb3150..8cbe8f2f96 100644
--- a/src/backend/commands/variable.c
+++ b/src/backend/commands/variable.c
@@ -1033,13 +1033,11 @@ check_application_name(char **newval, void **extra, GucSource source)
 		return false;
 
 	ret = guc_strdup(WARNING, clean);
+	free(clean);
+
 	if (!ret)
-	{
-		pfree(clean);
 		return false;
-	}
 
-	pfree(clean);
 	*newval = ret;
 	return true;
 }
@@ -1069,13 +1067,11 @@ check_cluster_name(char **newval, void **extra, GucSource source)
 		return false;
 
 	ret = guc_strdup(WARNING, clean);
+	free(clean);
+
 	if (!ret)
-	{
-		pfree(clean);
 		return false;
-	}
 
-	pfree(clean);
 	*newval = ret;
 	return true;
 }